<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}


// 步骤1.设置appid和appsecret
$appid = $setData['appId']; //此处填写绑定的微信公众号的appid
$appsecret = $setData['appsecret']; //此处填写绑定的微信公众号的密钥id



// 步骤2.生成签名的随机串
function nonceStr($length){
    $str = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJK1NGJBQRSTUVWXYZ';//随即串，62个字符
    $strlen = 62;
    while($length > $strlen){
        $str .= $str;
        $strlen += 62;
    }
    $str = str_shuffle($str);
    return substr($str,0,$length);
}


// 步骤3.获取access_token
loadcache('zuso_wxfx_acc');
if($_G['cache']['zuso_wxfx_acc'] && $setData['debug'] == 0){
    if(time() - $_G['cache']['zuso_wxfx_acc']['time'] < $setData['ctime']){
        $access_token = $_G['cache']['zuso_wxfx_acc']['access_token'];
         
    }else{
        $result = http_get('https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid='.$appid.'&secret='.$appsecret);
        $json = json_decode($result,true);
        $access_token = $json['access_token'];
        savecache('zuso_wxfx_acc',array('access_token'=>$access_token,'time'=>time()));
        
    }
}else{
    $result = http_get('https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid='.$appid.'&secret='.$appsecret);
    $json = json_decode($result,true);
    $access_token = $json['access_token'];
    savecache('zuso_wxfx_acc',array('access_token'=>$access_token,'time'=>time()));
}




function http_get($url){
    //return ''; //关闭请求
    $oCurl = curl_init();
    if(stripos($url,"https://")!==FALSE){
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($oCurl, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($oCurl, CURLOPT_SSLVERSION, 1); //CURL_SSLVERSION_TLSv1
    }
    curl_setopt($oCurl, CURLOPT_URL, $url);
    curl_setopt($oCurl, CURLOPT_RETURNTRANSFER, 1 );
    $sContent = curl_exec($oCurl);
    $aStatus = curl_getinfo($oCurl);
    curl_close($oCurl);
    if(intval($aStatus["http_code"])==200){
        return $sContent;
    }else{
        return false;
    }
}

// 步骤4.获取ticket
$url = "https://api.weixin.qq.com/cgi-bin/ticket/getticket?type=jsapi&access_token=$access_token";
$res = json_decode( http_get ( $url ) );
$ticket = $res->ticket;


// 步骤5.生成wx.config需要的参数
$surl = $_G['siteurl'].substr($_SERVER["REQUEST_URI"],1);

$ws = getWxConfig( $ticket,$surl,time(),nonceStr(16),$appid);

function getWxConfig($jsapiTicket,$myurl,$timestamp,$nonceStr,$appid) {
    $string = "jsapi_ticket=$jsapiTicket&noncestr=$nonceStr&timestamp=$timestamp&url=$myurl";
    $signature = sha1 ( $string );
    $WxConfig["appid"] = $appid;
    $WxConfig["noncestr"] = $nonceStr;
    $WxConfig["timestamp"] = $timestamp;
    $WxConfig["url"] = $myurl;
    $WxConfig["signature"] = $signature;
    $WxConfig["rawstring"] = $string;
    return $WxConfig;
}






?>